
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="X-UA-Compatible" content="IE=Edge" />
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <title>Voyager.Actions.LocalRNP &#8212; PhaserVoyager 0.0.1 documentation</title>
    <link rel="stylesheet" href="../../../_static/sphinxdoc.css" type="text/css" />
    <link rel="stylesheet" href="../../../_static/pygments.css" type="text/css" />
    <script type="text/javascript" id="documentation_options" data-url_root="../../../" src="../../../_static/documentation_options.js"></script>
    <script type="text/javascript" src="../../../_static/jquery.js"></script>
    <script type="text/javascript" src="../../../_static/underscore.js"></script>
    <script type="text/javascript" src="../../../_static/doctools.js"></script>
    <script type="text/javascript" src="../../../_static/language_data.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
  </head><body>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" accesskey="U">Module code</a> &#187;</li> 
      </ul>
    </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    </div>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <h1>Source code for Voyager.Actions.LocalRNP</h1><div class="highlight"><pre>
<span></span>
<span class="c1">#! /usr/bin/env python</span>
<span class="c1"># -*- coding: utf-8 -*-</span>

<span class="c1">#####################################################################</span>
<span class="c1">#  Copyright and authorship belong to:                              #</span>
<span class="c1">#  @author: Massimo Sammito                                         #</span>
<span class="c1">#  @email: mds83@cam.ac.uk / massimo.sammito@gmail.com              #</span>
<span class="c1">#####################################################################</span>
<span class="c1">#####################################################################</span>
<span class="c1">#                              LICENSE                              #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#                                                                   #</span>
<span class="c1">#####################################################################</span>

<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">print_function</span>
<span class="kn">from</span> <span class="nn">__future__</span> <span class="kn">import</span> <span class="n">division</span>
<span class="kn">from</span> <span class="nn">future.standard_library</span> <span class="kn">import</span> <span class="n">install_aliases</span>
<span class="kn">from</span> <span class="nn">libtbx.phil</span> <span class="kn">import</span> <span class="n">parse</span>

<span class="n">install_aliases</span><span class="p">()</span>

<span class="kn">import</span> <span class="nn">sys</span><span class="o">,</span><span class="nn">os</span><span class="o">,</span><span class="nn">copy</span>
<span class="kn">import</span> <span class="nn">traceback</span>
<span class="kn">from</span> <span class="nn">voyager_actions</span> <span class="kn">import</span> <span class="n">Action</span>

<span class="c1">#DISCLAIMER#</span>
<span class="c1">#This class has been generated automatically through strategy_app.py</span>
<span class="c1">#The app does not verify the correctness of the written code</span>
<span class="c1">#Please validate the class before use and manually inspect and correct any error</span>

<div class="viewcode-block" id="LocalRNP_exception"><a class="viewcode-back" href="../../../Voyager.Actions.LocalRNP.html#Voyager.Actions.LocalRNP.LocalRNP_exception">[docs]</a><span class="k">class</span> <span class="nc">LocalRNP_exception</span><span class="p">(</span><span class="ne">Exception</span><span class="p">):</span>
    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">msg</span><span class="p">):</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">LocalRNP_exception</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">msg</span><span class="p">)</span></div>
        
<div class="viewcode-block" id="LocalRNP"><a class="viewcode-back" href="../../../Voyager.Actions.LocalRNP.html#Voyager.Actions.LocalRNP.LocalRNP">[docs]</a><span class="k">class</span> <span class="nc">LocalRNP</span><span class="p">(</span><span class="n">Action</span><span class="p">):</span>
    <span class="n">info_dag_nodes</span> <span class="o">=</span> <span class="p">{</span><span class="s2">&quot;hkl_input&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;hkl_output&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;model_input&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;model_output&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">,</span><span class="s2">&quot;occurrences&quot;</span><span class="p">:</span><span class="s2">&quot;*&quot;</span><span class="p">}</span>
    <span class="n">rule</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;[[&quot;CellContentAnalysis&quot;]]&quot;&quot;&quot;</span>
    <span class="n">phasertngphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;</span>
<span class="s2">&quot;&quot;&quot;</span>
    <span class="n">masterphil</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot;voyager.LocalRNP {</span>
<span class="s2">rmsd = 0.2</span>
<span class="s2">  .type = float(value_min=0)</span>
<span class="s2">  .expert_level = 0</span>
<span class="s2">  .optional = True</span>
<span class="s2">  .short_caption = Angstrom RMSD</span>
<span class="s2">  .help = Angstrom RMSD of the model to the final structure. RMSD written in cards overwite this value.</span>
<span class="s2">}&quot;&quot;&quot;</span>
    <span class="n">helpstring</span> <span class="o">=</span> <span class="s2">&quot;&quot;&quot; This action performs a local rigid body refinement refinement of the model in its original position. The model is the latest modelid in the voyager_dag in the path to root. It can read the associated rmsd from the pdb card or can be given as input.&quot;&quot;&quot;</span>

    <span class="k">def</span> <span class="fm">__init__</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">name</span> <span class="o">=</span> <span class="s1">&#39;LocalRNP&#39;</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="n">strategy</span><span class="o">.</span><span class="n">arguments</span>
        <span class="nb">super</span><span class="p">(</span><span class="n">LocalRNP</span><span class="p">,</span> <span class="bp">self</span><span class="p">)</span><span class="o">.</span><span class="fm">__init__</span><span class="p">(</span><span class="n">strategy</span><span class="p">,</span> <span class="n">current_phil_keywords</span><span class="p">)</span>

<div class="viewcode-block" id="LocalRNP.check_imports"><a class="viewcode-back" href="../../../Voyager.Actions.LocalRNP.html#Voyager.Actions.LocalRNP.LocalRNP.check_imports">[docs]</a>    <span class="k">def</span> <span class="nf">check_imports</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">b</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">test</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;test() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">c</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">help</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;help() method has not been implemented!&quot;</span><span class="p">)</span>
        <span class="k">try</span><span class="p">:</span>
            <span class="n">d</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">get_name</span><span class="p">()</span>
        <span class="k">except</span><span class="p">:</span>
            <span class="k">raise</span> <span class="ne">NotImplementedError</span><span class="p">(</span><span class="s2">&quot;get_name() method has not been implemented!&quot;</span><span class="p">)</span>
        
        <span class="bp">self</span><span class="o">.</span><span class="n">iotbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">fetch</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;iotbx.pdb.fetch&quot;</span><span class="p">,</span><span class="n">fromlist</span><span class="o">=</span><span class="p">[</span><span class="s2">&quot;fetch&quot;</span><span class="p">])</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">cctbx</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;cctbx&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">system_utility</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;system_utility&quot;</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">simple_tools</span> <span class="o">=</span> <span class="nb">__import__</span><span class="p">(</span><span class="s2">&quot;simple_tools&quot;</span><span class="p">)</span>


        <span class="k">return</span> <span class="kc">True</span></div>

<div class="viewcode-block" id="LocalRNP.test"><a class="viewcode-back" href="../../../Voyager.Actions.LocalRNP.html#Voyager.Actions.LocalRNP.LocalRNP.test">[docs]</a>    <span class="k">def</span> <span class="nf">test</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="c1">#TODO: perform a complete self contained test</span>
        <span class="k">pass</span></div>
    
<div class="viewcode-block" id="LocalRNP.help"><a class="viewcode-back" href="../../../Voyager.Actions.LocalRNP.html#Voyager.Actions.LocalRNP.LocalRNP.help">[docs]</a>    <span class="k">def</span> <span class="nf">help</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">helpstring</span></div>
    
<div class="viewcode-block" id="LocalRNP.get_name"><a class="viewcode-back" href="../../../Voyager.Actions.LocalRNP.html#Voyager.Actions.LocalRNP.LocalRNP.get_name">[docs]</a>    <span class="k">def</span> <span class="nf">get_name</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">name</span></div>
    
<div class="viewcode-block" id="LocalRNP.run"><a class="viewcode-back" href="../../../Voyager.Actions.LocalRNP.html#Voyager.Actions.LocalRNP.LocalRNP.run">[docs]</a>    <span class="k">def</span> <span class="nf">run</span><span class="p">(</span><span class="bp">self</span><span class="p">):</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_start</span><span class="p">()</span>
        <span class="k">if</span> <span class="ow">not</span> <span class="nb">hasattr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="s2">&quot;logger&quot;</span><span class="p">):</span> <span class="k">raise</span> <span class="n">LocalRNP_exception</span><span class="p">(</span><span class="s2">&quot;Logger File has not been set. Please call &#39;set_logger_file&#39; method before run&quot;</span><span class="p">)</span>
        <span class="n">user_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">format</span><span class="p">(</span><span class="n">python_object</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="n">diffuser_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">user_phil</span><span class="p">)</span>
        <span class="n">action_phil</span> <span class="o">=</span> <span class="n">parse</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">current_phil_keywords</span><span class="p">)</span>
        <span class="n">diffaction_phil</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch_diff</span><span class="p">(</span><span class="n">source</span><span class="o">=</span><span class="n">action_phil</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">program_master_phil</span><span class="o">.</span><span class="n">fetch</span><span class="p">(</span><span class="n">sources</span><span class="o">=</span><span class="p">[</span><span class="n">diffaction_phil</span><span class="p">,</span> <span class="n">diffuser_phil</span><span class="p">])</span><span class="o">.</span><span class="n">extract</span><span class="p">()</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">local_rnp</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="p">)</span>
        <span class="bp">self</span><span class="o">.</span><span class="n">notify_end</span><span class="p">()</span>
        <span class="k">return</span> <span class="n">output</span></div>

<div class="viewcode-block" id="LocalRNP.local_rnp"><a class="viewcode-back" href="../../../Voyager.Actions.LocalRNP.html#Voyager.Actions.LocalRNP.LocalRNP.local_rnp">[docs]</a>    <span class="k">def</span> <span class="nf">local_rnp</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">argsparse</span><span class="p">):</span>
        <span class="n">root</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">initial_dag_nodes</span>
        <span class="k">if</span> <span class="n">root</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
            <span class="n">root</span> <span class="o">=</span> <span class="kc">None</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">)</span> <span class="ow">and</span> <span class="nb">len</span><span class="p">(</span><span class="n">root</span><span class="p">)</span> <span class="o">==</span> <span class="mi">1</span><span class="p">:</span>
            <span class="n">root</span> <span class="o">=</span> <span class="n">root</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="k">elif</span> <span class="nb">isinstance</span><span class="p">(</span><span class="n">root</span><span class="p">,</span> <span class="nb">list</span><span class="p">):</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">error</span><span class="p">(</span><span class="s2">&quot;This action only support one single input dag node&quot;</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">LocalRNP_exception</span><span class="p">(</span><span class="s2">&quot;This action only support one single input dag node&quot;</span><span class="p">)</span>

        <span class="n">noder</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">get_most_recent_node_with_pdb_model</span><span class="p">(</span><span class="n">root</span><span class="p">)</span>
        <span class="k">if</span> <span class="n">noder</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span> <span class="k">raise</span> <span class="n">LocalRNP_exception</span><span class="p">(</span><span class="s2">&quot;Cannot find any pdb model in the current dag branch&quot;</span><span class="p">)</span>
        <span class="n">modelid</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">noder</span><span class="p">)[</span><span class="s2">&quot;model_identifier&quot;</span><span class="p">]</span>
        <span class="n">strat</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">strategy</span><span class="o">.</span><span class="n">G</span><span class="o">.</span><span class="n">nodes</span><span class="p">[</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">noder</span><span class="p">)[</span><span class="s2">&quot;strategy_node&quot;</span><span class="p">]][</span><span class="s2">&quot;name&quot;</span><span class="p">]</span>
    
        <span class="n">files</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_extract_from_db</span><span class="p">(</span><span class="n">modelid</span><span class="p">,</span> <span class="n">in_memory</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
        <span class="n">pdb</span> <span class="o">=</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">abspath</span><span class="p">(</span><span class="n">files</span><span class="p">[</span><span class="mi">0</span><span class="p">])</span>
        <span class="n">files</span> <span class="o">+=</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_extract_from_db</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">root</span><span class="p">)[</span><span class="s2">&quot;data_identifier&quot;</span><span class="p">],</span> <span class="n">in_memory</span><span class="o">=</span><span class="kc">False</span><span class="p">)</span>
    
        <span class="c1"># output = self.tng.mode_eca(self, self.voyager_dag.nodes(root)[&quot;dag_cards&quot;], pdb, verbose=self.tngverbose)</span>
        <span class="c1"># if self.verbose: print(output)</span>
        <span class="c1">#</span>
        <span class="c1"># if self.tng.ErrorMessage:</span>
        <span class="c1">#     self.notify_error(self.tng.ErrorMessage)</span>
        <span class="c1">#     raise LocalRNP_exception(self.tng.ErrorMessage)</span>
        <span class="c1">#</span>
        <span class="c1"># if self.tng.WarningMessage:</span>
        <span class="c1">#     self.notify_warning(self.tng.WarningMessage)</span>
        <span class="c1">#     print(self.tng.WarningMessage)</span>
        <span class="n">rmsd</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">argsparse</span><span class="o">.</span><span class="n">voyager</span><span class="o">.</span><span class="n">LocalRNP</span><span class="o">.</span><span class="n">rmsd</span>
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">mode_eca_ens</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">voyager_dag</span><span class="o">.</span><span class="n">nodes</span><span class="p">(</span><span class="n">root</span><span class="p">)[</span><span class="s2">&quot;dag_cards&quot;</span><span class="p">],</span> <span class="n">pdb</span><span class="p">,</span> <span class="n">fast</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">tngverbose</span><span class="p">,</span> <span class="n">rmsd</span><span class="o">=</span><span class="n">rmsd</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">verbose</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="n">output</span><span class="p">)</span>
    
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">notify_error</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">LocalRNP_exception</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>
    
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">notify_warning</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">)</span>
    
        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">mode_eens</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">dag_cards_str_list</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_dag_list</span><span class="p">[</span><span class="mi">0</span><span class="p">],</span> <span class="n">verbose</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">tngverbose</span><span class="p">)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">verbose</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="n">output</span><span class="p">)</span>
    
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">notify_error</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">LocalRNP_exception</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>
    
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">notify_warning</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">)</span>
    
        <span class="n">nodetext</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">dag_cards_str_list</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span>
        <span class="n">nodetext</span> <span class="o">+=</span> <span class="s2">&quot;&quot;&quot;</span>
<span class="s2">phasertng node pose identifier &quot;&quot;&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_dag_list</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">node</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">identifier</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot;&quot;&quot; tag </span><span class="se">\&quot;</span><span class="s2">&quot;&quot;&quot;</span><span class="o">+</span><span class="nb">str</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_dag_list</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">node</span><span class="o">.</span><span class="n">entry</span><span class="p">[</span><span class="mi">0</span><span class="p">]</span><span class="o">.</span><span class="n">tag</span><span class="p">)</span><span class="o">+</span><span class="s2">&quot;&quot;&quot;</span><span class="se">\&quot;</span><span class="s2"> euler 0 0 0 fractional 0 0 0 orthogonal_rotation  0 0 0 orthogonal_translation 0 0 0 bfactor 0 multiplicity 1 tncs_group 1 clash 0 0 0        </span>
<span class="s2">        &quot;&quot;&quot;</span>

        <span class="n">output</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">mode_rbr</span><span class="p">(</span><span class="bp">self</span><span class="p">,</span> <span class="n">nodetext</span><span class="p">,</span> <span class="n">verbose</span><span class="o">=</span><span class="bp">self</span><span class="o">.</span><span class="n">tngverbose</span><span class="p">)</span><span class="c1">#self.tngverbose)</span>
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">verbose</span><span class="p">:</span> <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="n">output</span><span class="p">)</span>
    
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">notify_error</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>
            <span class="k">raise</span> <span class="n">LocalRNP_exception</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">ErrorMessage</span><span class="p">)</span>
    
        <span class="k">if</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">:</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">notify_warning</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">)</span>
            <span class="bp">self</span><span class="o">.</span><span class="n">logger</span><span class="o">.</span><span class="n">info</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">WarningMessage</span><span class="p">)</span>
    
        <span class="n">allfiles</span> <span class="o">=</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_parameters</span><span class="o">.</span><span class="n">phasertng</span><span class="o">.</span><span class="n">get_filenames</span>

        <span class="c1">#TODO: I have to call a new mode in phasertng to actually write down the pdb and the map but it is not yet implemented.</span>

        <span class="k">for</span> <span class="n">file</span> <span class="ow">in</span> <span class="n">files</span><span class="p">:</span>
            <span class="k">if</span> <span class="n">os</span><span class="o">.</span><span class="n">path</span><span class="o">.</span><span class="n">exists</span><span class="p">(</span><span class="n">file</span><span class="p">):</span>
                <span class="n">os</span><span class="o">.</span><span class="n">remove</span><span class="p">(</span><span class="n">file</span><span class="p">)</span>
    
        <span class="k">return</span> <span class="bp">self</span><span class="o">.</span><span class="n">schedule_add_node_solution</span><span class="p">(</span><span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">dag_phil_str_list</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">dag_cards_str_list</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_dag_list</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">tng</span><span class="o">.</span><span class="n">working_parameters</span><span class="p">,</span> <span class="s2">&quot;solution&quot;</span><span class="p">,</span> <span class="n">root</span><span class="p">,</span> <span class="bp">self</span><span class="o">.</span><span class="n">associated_strategy_node</span><span class="p">,</span> <span class="n">data</span><span class="o">=</span><span class="kc">None</span><span class="p">,</span> <span class="n">probability</span><span class="o">=</span><span class="kc">None</span><span class="p">)[</span><span class="mi">0</span><span class="p">][</span><span class="mi">0</span><span class="p">]</span></div></div>
</pre></div>

          </div>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../../../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../../index.html">PhaserVoyager 0.0.1 documentation</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../index.html" >Module code</a> &#187;</li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2020, Massimo D. Sammito.
      Created using <a href="http://sphinx-doc.org/">Sphinx</a> 1.8.5.
    </div>
  </body>
</html>